/// <reference types="node" />
import { PathLike } from 'fs';
import { Idl } from './types';
import { Options } from 'prettier';
export * from './types';
export declare class Solita {
    private readonly idl;
    private readonly formatCode;
    private readonly formatOpts;
    private readonly accountsHaveImplicitDiscriminator;
    private readonly prependGeneratedWarning;
    constructor(idl: Idl, { formatCode, formatOpts, prependGeneratedWarning, }?: {
        formatCode?: boolean;
        formatOpts?: Options;
        prependGeneratedWarning?: boolean;
    });
    accountTypes(): Set<string>;
    customTypes(): Set<string>;
    resolveFieldType: (typeName: string) => import("./types").IdlTypeEnum | import("./types").IdlDefinedType | null;
    renderCode(): {
        instructions: Record<string, string>;
        accounts: Record<string, string>;
        types: Record<string, string>;
        errors: string | null;
    };
    renderAndWriteTo(outputDir: PathLike): Promise<void>;
    private writeInstructions;
    private writeAccounts;
    private writeTypes;
    private writeErrors;
    writeMainIndex(outputDir: PathLike, reexports: string[]): Promise<void>;
}
